<script setup lang="ts">
const props = withDefaults(
  defineProps<{
    imageId: string;
    status: "PENDING" | "APPROVED";
    height?: number;
  }>(),
  {
    height: 250,
  },
);

const { imageUrl } = useImageService();
const { loggedIn } = useOidcAuth();
const shouldFetchByAPI = computed(
  () => props.status !== "APPROVED" && loggedIn.value,
);
</script>

<template>
  <client-only>
    <a v-if="!shouldFetchByAPI" :href="imageUrl(props.imageId)" target="_blank">
      <div class="d-inline-flex align-center text-center mr-1 flex-column">
        <v-img
          v-if="props.status === 'APPROVED'"
          class="flex-grow-1"
          :src="imageUrl(props.imageId, props.height)"
          :height="props.height"
          :min-width="props.height"
        >
          <template #error>
            <v-sheet
              flat
              border
              color="secondary"
              :height="props.height"
              :width="props.height"
              class="d-flex align-center justify-center"
            >
              Failed to fetch image
            </v-sheet>
          </template>
        </v-img>
        <v-sheet
          v-else
          flat
          border
          color="secondary"
          :height="props.height"
          :width="props.height"
          class="d-flex align-center justify-center"
        >
          Image not reviewed yet
        </v-sheet>
      </div></a
    >
    <LazyImageHolderApiFetch
      v-else
      :image-id="props.imageId"
      :height="props.height"
    />
  </client-only>
</template>
